package com.qgs.dc.s7.retrydemo;


import org.apache.commons.lang3.RandomUtils;
import org.springframework.remoting.RemoteAccessException;

/**
 * @Author: cx
 * @Description:
 */
public class RetryDemoTask {
    /**
     * 重试方法
     * @return
     */
    public static boolean retryTask(String param)  {
        System.out.println("retry-task : 收到请求参数:"+param);

        int i = RandomUtils.nextInt(0,11);
        System.out.println("retry-task : 随机生成的数:"+i);
        if (i == 0) {
            System.out.println("retry-task : 为0,抛出参数异常.");
            //因为Illeague这个异常我们没有在exceptionMap里面配置，所以 抛出这个异常后
            //spring-retry不会进行重试，而是会直接进入recovery函数
            throw new IllegalArgumentException("retry-task : 参数异常");
        }else if (i  == 1){
            System.out.println("retry-task : 为1,返回true.");
            return true;
        }else if (i == 2){
            System.out.println("retry-task : 为2,返回false.");
            return false;
        }else{
            //因为RemoteAccessExcep这个异常我们在exceptionMap里面配置了，所以 抛出这个异常后
            //spring-retry会进行重试
            System.out.println("retry-task : 大于2,抛出自定义异常.");
            throw new RemoteAccessException("retry-task : 大于2,抛出远程访问异常");
        }
    }
}
